#include <iostream>

void processArray(int *arr, int N) {
    // Process each element in the array serially
    for (int i = 0; i < N; ++i) {
        arr[i] *= 2; // Multiply each element by 2
    }
}

int main() {
    const int N = 100000; // Size of the array
    int *arr = new int[N]; // Dynamically allocate memory for the array

    // Initialize the array
    for (int i = 0; i < N; ++i) {
        arr[i] = i;
    }

    // Process the array using the serial function
    processArray(arr, N);

    // Print first 10 elements to verify
    for (int i = 0; i < 10; ++i) {
        std::cout << arr[i] << " ";
    }
    std::cout << std::endl;

    // Free the dynamically allocated memory
    delete[] arr;

    return 0;
}

